VERSION 5.00
Begin VB.Form mainF 
   Appearance      =   0  '2D
   BackColor       =   &H00C0C0C0&
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3315
   ClientLeft      =   1125
   ClientTop       =   1605
   ClientWidth     =   6285
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   3315
   ScaleWidth      =   6285
   Begin VB.CommandButton Command8 
      Caption         =   "Reset"
      Height          =   375
      Left            =   240
      TabIndex        =   7
      Top             =   90
      Width           =   1560
   End
   Begin VB.TextBox TxtNote 
      Height          =   375
      Left            =   5040
      TabIndex        =   6
      Text            =   "C"
      Top             =   90
      Width           =   1050
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Spiele Note:"
      Height          =   375
      Left            =   3720
      TabIndex        =   5
      Top             =   75
      Width           =   1230
   End
   Begin VB.ListBox lst_sound_list 
      Appearance      =   0  '2D
      Height          =   2370
      Left            =   3960
      TabIndex        =   2
      Top             =   825
      Width           =   2175
   End
   Begin VB.CommandButton Command1 
      Appearance      =   0  '2D
      Caption         =   "Note C4 spielen"
      Height          =   375
      Left            =   1980
      TabIndex        =   1
      Top             =   90
      Width           =   1545
   End
   Begin VB.ListBox List1 
      Appearance      =   0  '2D
      Height          =   2370
      Left            =   210
      TabIndex        =   0
      Top             =   825
      Width           =   3315
   End
   Begin VB.Label Label2 
      Appearance      =   0  '2D
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Sounds"
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   3960
      TabIndex        =   4
      Top             =   585
      Width           =   645
   End
   Begin VB.Label Label1 
      Appearance      =   0  '2D
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Devices"
      ForeColor       =   &H80000008&
      Height          =   195
      Left            =   255
      TabIndex        =   3
      Top             =   585
      Width           =   705
   End
End
Attribute VB_Name = "mainF"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source !
'
' Autor: K. Langbein Klaus@ActiveVB.de

' Chronologie:
' Dieser Sourcecode basiert auf der Vorarbeit von M. Levoi
' mlevoi@modemss.brisnet.org.au. Die ursprnglichen Midi-Routinen wurden
' in MIDI_CMD zusammengefasst.

' berarbeitet und kommentiert von Thomas Rodemer, Thomas@ActveVB.de

' Kleiner Hinweis: Falls das Programm ber die IDE beendet wurde, whrend
' der Ausgabekanal noch offen war, kann beim Neustart der Midikanal nicht
' initialisiert werden. Daher wird bei jeder Initialisierung des Midi-Kanals
' (in midi_out_open) das entsprechende Handle in ein File geschrieben. Per
' Reset-Button knnen nach einem Neustart alle zuvor geffneten Handles
' geschlossen werden.

Option Explicit

Private Sub fill_sound_list()

'Einlesen der Beispiel-Soundliste

    Dim s As String

    Open App.Path & "\genmidi.txt" For Input As #1
    Do While Not EOF(1)
        Line Input #1, s
        lst_sound_list.AddItem s
    Loop
    Close #1
    
End Sub

Private Sub Command1_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    
    'Die Note C4 abspielen
    Call note_on(0, 60, vol)

End Sub

Private Sub Command1_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    
    'Alle Ton-Ausgaben abbrechen
    all_sounds_off
    
End Sub


Private Sub Command4_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    
    'Die Note des Textfeldes abspielen
    Dim A$
    A$ = TxtNote.Text
    Call play_note(A$, vol)
    
End Sub


Private Sub Command4_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    
    'Alle Ton-Ausgaben abbrechen
    all_sounds_off
    
End Sub


Private Sub Command8_Click()

    ' Der Reset-Knopf
    Call midi_out_close
    Call free_old_midi_handles(chop_slash(App.Path) + "\handles.log")
    sett = 1
    List1.ListIndex = 0
    sett = 0
    List1.ListIndex = 1
    
End Sub

Private Sub Form_Load()
                 
    Call midi_listoutdevs(List1)
    Call fill_sound_list

    List1.ListIndex = 1
    vol = 127
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Den Ausgabekanal freigeben
    midi_out_close
    
End Sub



Private Sub List1_Click()

    ' Wird ein Item in List1 geklickt, den gewnschten Sound abspielen
    Dim x  As Integer
    If sett = 0 Then
        midi_out_close
        If List1.ListIndex > 0 Then
            x = midi_out_open(List1.ItemData(List1.ListIndex))
        End If
    End If
    
End Sub

Private Sub lst_sound_list_KeyDown(KeyCode As Integer, Shift As Integer)

    ' Wenn Enter-Taste gedrckt worden, den gewnschten Sound abspielen
    If KeyCode = 13 Then
        Call program_change(0, 0, lst_sound_list.ListIndex)
        Call note_on(0, 60, vol)
    End If
    
End Sub

Private Sub lst_sound_list_MouseDown(Button As Integer, _
    Shift As Integer, x As Single, Y As Single)
    
    ' Wird ein Item in List1 geklickt, den gewnschten Sound abspielen
    Call program_change(0, 0, lst_sound_list.ListIndex)
    Call note_on(0, 60, vol)
    
End Sub

Private Sub lst_sound_list_MouseUp(Button As Integer, _
    Shift As Integer, x As Single, Y As Single)
    
    'Alle Ton-Ausgaben abbrechen
    all_sounds_off
    
End Sub

