Attribute VB_Name = "KL_MIDI"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source !
'
' Autor: K. Langbein Klaus@ActiveVB.de

Option Explicit

Global stopp As Long
Global key_on(255) As Long
Global sett As Long
Global vol As Integer

Function free_old_midi_handles(ByVal Fname As String)

    Dim f_in$, test$, fno1, fno2, ll, test1$, dat$, timm$, typ$, htype$
    Dim hand$, midi_error, ero$
    
    f_in$ = get_path(Fname$) + "\temp.log"
    test$ = Dir$(f_in$)
    If test$ <> "" Then
         Kill f_in$
    End If
    Name Fname$ As f_in$

    fno1 = FreeFile
    Open f_in$ For Input As #fno1
    
    fno2 = FreeFile
    Open Fname$ For Output As #fno2
    ll = LOF(fno1)

    Do
    
        Line Input #fno1, test1$
        test$ = test1$
        If test$ <> "" Then
            dat$ = bite(test$, " ")
        End If
        If test$ <> "" Then
            timm$ = bite(test$, " ")
        End If
        If test$ <> "" Then
            typ$ = bite(test$, " ")
        End If
        If test$ <> "" Then
            htype$ = bite(test$, " ")
        End If
        If test$ <> "" Then
            hand = Val(bite(test$, " "))
        End If
        
        If LCase(typ$) = "new" Then
            If LCase(htype$) = "midi-handle" Then
                If hand <> 0 Then
                    midi_error = midiOutClose(hand)
                    If midi_error <> 0 Then
                        ero$ = "Error: " + Format$(midi_error)
                    Else
                        ero$ = "No Error"
                    End If
                    test$ = dat$ + " " + timm$ + " " + "Released" + " " + htype$ + " " + _
                        Format$(hand) + " " + ero$ + " at " + Date$ + " " + Time$ + vbCrLf
                    Print #fno2, test$;
                Else
                    Print #fno2, test1$ + vbCrLf;
                End If
            Else
                Print #fno2, test1$ + vbCrLf;
            End If
        
        Else
            Print #fno2, test1$ + vbCrLf;

        End If
        
    
    Loop Until Seek(fno1) >= ll
    
    Close #fno1
    Close #fno2
 
End Function

Function play_note(ByVal A$, ByVal vv As Integer) As Long

    ' Diese Funktion spielt den gewnschten Sound ab.
    ' Die einzelnen Tne werden in die entsprechenden
    ' Werte gendert, mit einer Pause versehen und
    ' anschlieend ausgegeben.
    
    Dim note As Integer
    Dim okt As Integer
    Dim i As Long
    Dim j As Long
    Dim kk As Long
    Dim n$
    Dim k$
    Dim ch
    Dim off As Long
    Dim num$
    
    For i = 1 To Len(A$)
        k$ = Mid$(A$, i, 1)
        kk = Asc(k$)
        If (kk < 65) Then
            j = i
            Exit For
        End If
        
    Next i
    
    If j > 0 Then
        If j - 1 < Len(A$) Then
            n$ = Left$(A$, j - 1)
            num$ = Right$(A$, Len(A$) - Len(n$))
            okt = Val(num$) - 1
        End If
    Else
        n$ = A$
    End If
        
    Select Case n$
    
    Case "c"
        off = 0
    Case "cis"
        off = 1
    Case "d"
        off = 2
    Case "dis"
        off = 3
    Case "e"
        off = 4
    Case "f"
        off = 5
    Case "fis"
        off = 6
    Case "g"
        off = 7
    Case "gis"
        off = 8
    Case "a"
        off = 9
    Case "ais"
        off = 10
    Case "h"
        off = 11
        
    Case "p"
        Call pause(okt * 0.1, 0)
        okt = 0
        
    End Select
    
    If n$ <> "p" Then
        note = 60 + okt * 12 + off
        Call midi_outshort(&H90 + ch, note, vv)
        play_note = note
    End If
    
End Function


Function write_handle(ByVal Fname$, ByVal htype$, ByVal hand As Long) As Long

    ' Schreibt in die Log-Datei
    Dim fno, test$
    
    fno = FreeFile
    Open Fname$ For Append As #fno
    If LOF(fno) > 0 Then
        Seek #fno, LOF(fno) + 1
    End If
    
    test$ = Date$ + " " + Time$ + " New " + htype$ + " " + Format$(hand) + vbCrLf
    
    Print #fno, test$;
    Close #fno

End Function


